﻿
Public Class DeLijnen
    Private MaandNaam(12) As String
    Private BTM As Bitmap
    Private Schaal As Single = 0.9
    Private Reeel As Boolean = False
    'NietReeel geeft aan of de zon boven de horizon en boven de zonnewijzer zichtbaar is.
    Private Seizoen As String
    'Seizoen geeft bij het tekenen van de Seizoens- / datum-lijnen het seizoen aan
    Private Straal As Object = Math.Sqrt((Me.Width / 14) ^ 2 + (Me.Height / 20) ^ 2)
    'Straal geeft de minimale afstand tussen de afgedrukte getallen in de tekening


    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub Form1_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        Me.Text = "ZonnewijzerKompas"
        '"fX: " & Me.Width & ",   fY: " & Me.Height & ",   cX: " & Me.ClientSize.Width & ",   cY: " & Me.ClientSize.Height
    End Sub

    Private Sub PrintDocument1_PrintPage(sender As Object, e As Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim NT As Graphics = e.Graphics
        NT.DrawImage(Me.BackgroundImage, 0, 0)
    End Sub

    Private Sub btnAfdrukken_Click(sender As Object, e As EventArgs) Handles btnAfdrukken.Click
        Try
            PrintDocument1.Print()
        Catch ex As Exception
            MsgBox("Printerfout:" & vbCrLf & ex.Message)
        Finally
            If MsgBox("Is de afdruk geslaagd?", MsgBoxStyle.Question Or vbYesNo) = vbYes Then
                Me.Close()
            End If
        End Try
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim xx, hulp, yy, XfactorGnomon, YfactorGnomon As Single
        Dim NT As Graphics = Me.CreateGraphics
        Dim myPen As Pen
        Dim i, dn As Integer
        Dim Stap As Integer = 1
        Dim lambda As Object
        'lambda is de parameter van de richtingscoëfficiënt vande Stijl
        Dim maxdecl As Object
        Dim Begin As Object

        With Me
            .Height = Screen.PrimaryScreen.WorkingArea.Height
            .Width = 0.7 * Me.Height
        End With
        Me.Top = 0
        Hoogte = Me.Height

        'Factor van breedte (x) en hoogte (y) van de voet van de gnomon
        XfactorGnomon = 0.5
        YfactorGnomon = 0.3 + 0.1 * phi

        NT.PageUnit = GraphicsUnit.Pixel 'Point geeft op het beeldscherm dezelfde verhoudingen als op de printer?
        BTM = New Bitmap(Me.Width, Me.Height)
        NT = Graphics.FromImage(BTM)

        'Coördinaten van de oorsprong van de tekening (voet van de gnomon) in het assenstelsel van het beeldscherm en de printer
        myPen = New Pen(Brushes.Red, 2)
        Xoorsprong = Me.Width * XfactorGnomon - 10
        Yoorsprong = Me.Height * YfactorGnomon
        NT.DrawLine(myPen, CInt(Xoorsprong - 10), CInt(Yoorsprong), CInt(Xoorsprong + 10), CInt(Yoorsprong))
        NT.DrawLine(myPen, CInt(Xoorsprong), CInt(Yoorsprong - 10), CInt(Xoorsprong), CInt(Yoorsprong + 10))

        myPen = New Pen(Brushes.Red, 1)
        NT.DrawLine(myPen, Xoorsprong, Yoorsprong, Xoorsprong + f * gn, Yoorsprong)

        'Het voetpunt van de Stijl wordt getekend
        x0 = 0
        y0 = 0
        z0 = 1
        Omzettingx1y1()
        Omzettingx2y2()
        Omzettingx3y3()
        'Omzettingx4y4()
        lambda = (f * gn) / z3
        'xs = x4
        xs = Xoorsprong + lambda * x3
        ' = y4
        ys = YFlip(Yoorsprong + lambda * y3)

        myPen = New Pen(Brushes.Green, 2)
        If xs - 10 > 0 And xs + 10 < Me.Width And ys - 10 > 0 And ys + 10 < Me.Height Then
            NT.DrawLine(myPen, CInt(xs) - 10, CInt(ys), CInt(xs) + 10, CInt(ys))
            NT.DrawLine(myPen, CInt(xs), CInt(ys) - 10, CInt(xs), CInt(ys) + 10)
            myPen = New Pen(Brushes.Green, 1)
            NT.DrawLine(myPen, CInt(xs), CInt(ys), Xoorsprong + f * gn, Yoorsprong)
        End If


        'Lijnen voor Ware of Plaatselijke zonnetijd zonder TijdVereffening.
        myPen = New Pen(Brushes.Blue, 1)
        For i = -12 To 12
            x = 0
            y = 0
            Begin = 0
            hulp = i * 15
            'hulp is de uurhoek van de zon in graden
            Uurhoek = GradToRad(hulp)
            'Uurhoek is de uurhoek zonder TijdVereffening in radialen
            For dn = 172 To 355
                xx = x
                yy = y
                decl = declinatie(L(dn))
                'decl is de zonsdeclinatie in radialen
                Reeel = False
                TotaleOmzetting()
                'geeft coördinaten t.o.v. het voetpunt van de gnomon, de oorsprong
                If z1 > 0 And z3 > 0 Then
                    Reeel = True
                End If
                Omzettingxy()
                'geeft de coördinaten t.o.v. het assenstelsel op beeldscherm en printer

                If xx > 0 And xx < Me.Width - 30 And YFlip(yy) > 10 And YFlip(yy) < Me.Height - 10 And Reeel Then
                    If Begin = 0 Then
                        Tekst = CStr(i + 12)
                        'StringFormat.FormatFlags = StringFormatFlags.DirectionVertical
                        NT.DrawString(Tekst, New Font(LetterType, Lettergrootte), Brushes.Blue, x, YFlip(y) - 10)
                        ' NT.DrawString(CStr(i), New Font("Arial", 10), Brushes.DarkGreen, x, y)
                        Begin = Begin + 1
                    End If
                    NT.DrawLine(myPen, x, YFlip(y), xx, YFlip(yy))
                End If
            Next
        Next


        'SeizoensGrensLijnen (21/12, 21/3, 21/6 en 21/9 (valt samen met 21/3)
        myPen = New Pen(Brushes.Blue, 1)
        maxdecl = declinatie(L(172.4))
        For i = -1 To 1
            decl = i * maxdecl
            x = 0
            y = 0
            For j = -180 To 180 Step 1
                xx = x
                yy = y
                Uurhoek = GradToRad(j)
                Reeel = False
                TotaleOmzetting()
                'geeft coördinaten t.o.v. het voetpunt van de gnomon, de oorsprong
                If z1 > 0 And z3 > 0 Then
                    Reeel = True
                End If
                Omzettingxy()
                'geeft de coördinaten t.o.v. het assenstelsel op beeldscherm en printer

                If xx > 0 And xx < Me.Width - 30 And YFlip(yy) > 10 And YFlip(yy) < Me.Height - 10 And Reeel Then
                    NT.DrawLine(myPen, x, YFlip(y), xx, YFlip(yy))
                    If j = 0 Then

                        If (i = -1 And phi >= 0) Or (i = 1 And phi < 0) Then

                            NT.DrawString("Winter", New Font(LetterType, Lettergrootte), Brushes.Blue, x, YFlip(y) - Math.Sign(phi) * 15)

                        End If
                        If i = 0 Then
                            NT.DrawString("Lente en Herfst", New Font(LetterType, Lettergrootte), Brushes.Blue, x, YFlip(y) - Math.Sign(phi) * 15)
                        End If
                        If (i = 1 And phi >= 0) Or (i = -1 And phi < 0) Then
                            NT.DrawString("Zomer", New Font(LetterType, Lettergrootte), Brushes.Blue, x, YFlip(y) - Math.Sign(phi) * 15)
                        End If
                    End If
                End If
            Next
        Next



        'Tekening van de Analemmatische Zonnewijzer
        Dim a, b, xP, yP, yMaand As Integer
        Dim links, rechts, onder, boven, lengte As Object
        Dim uur, P As Object
        'uur is de uur aanduiding, P is de bijbehorende uurhoek
        Dim AF As Single
        'AF is de brandpuntsafstand
        Dim HalveDagBoog As Object

        a = CInt(0.9 * f * Me.Width / 2)
        b = CInt(a * f * Math.Sin(phi))

        MaandNaam(1) = "jan"
        MaandNaam(2) = "feb"
        MaandNaam(3) = "mrt"
        MaandNaam(4) = "apr"
        MaandNaam(5) = "mei"
        MaandNaam(6) = "jun"
        MaandNaam(7) = "jul"
        MaandNaam(8) = "aug"
        MaandNaam(9) = "sep"
        MaandNaam(10) = "okt"
        MaandNaam(11) = "nov"
        MaandNaam(12) = "dec"


        'Factor de hoogte (y) van de voet van de gnomon (Xoorsprong blijft bij beide tekeningen gelijk)
        YfactorGnomon = 0.75 - Math.Abs(phi) * 0.1

        'Coördinaten van de oorsprong van de tekening (voet van de gnomon) in het assenstelsel van het beeldscherm en de printer
        myPen = New Pen(Brushes.DarkOrange, 3)

        Yoorsprong = Me.Height * YfactorGnomon
        NT.DrawLine(myPen, CInt(Xoorsprong - 10), CInt(Yoorsprong), CInt(Xoorsprong + 10), CInt(Yoorsprong))
        NT.DrawLine(myPen, CInt(Xoorsprong), CInt(Yoorsprong - 10), CInt(Xoorsprong), CInt(Yoorsprong + 10))

        maxdecl = declinatie(L(172.4))
        lengte = a * Math.Cos(Math.Abs(phi) - maxdecl) / Math.Cos(maxdecl)
        myPen = New Pen(Brushes.Black, 1)
        'Assen en brandpunten van de Zonnewijzer Tekenen
        links = Xoorsprong - a
        'links geeft linker X-waarde van de Oost-West as
        rechts = Xoorsprong + a
        'rechts geeft rechter X-waarde van de Oost-West as
        onder = Yoorsprong + b
        'onder geeft onder Y-waarde van de Noord-Zuid as
        boven = Yoorsprong - b
        'boven geeft boven Y-waarde van de Noord-Zuid as
        AF = CInt(a * f * Math.Cos(phi))
        NT.DrawLine(myPen, links, Yoorsprong, rechts, Yoorsprong)
        NT.DrawLine(myPen, Xoorsprong, onder, Xoorsprong, boven)
        myPen = New Pen(Brushes.DarkOrange, 3)
        NT.DrawLine(myPen, Xoorsprong - AF, Yoorsprong - 10, Xoorsprong - AF, Yoorsprong + 10)
        NT.DrawString("F2", New Font(LetterType, Lettergrootte), Brushes.DarkOrange, Xoorsprong + AF, Yoorsprong + 10)
        NT.DrawLine(myPen, Xoorsprong + AF, Yoorsprong - 10, Xoorsprong + AF, Yoorsprong + 10)
        NT.DrawString("F1", New Font(LetterType, Lettergrootte), Brushes.DarkOrange, Xoorsprong - AF, Yoorsprong + 10)

        myPen = New Pen(Brushes.Black, 1)
        'Kruisjes van de uren en de uur aanduidingen
        For uur = -12 To 12
            P = GradToRad(uur * 15)
            HalveDagBoog = Math.Acos(-Math.Tan(phi) * Math.Tan(maxdecl * Math.Sign(phi)))
            'is de tijd in radialen
            If (P > -HalveDagBoog And P < HalveDagBoog) Or Math.Abs(phi) > pi / 2 - maxdecl Then
                xP = a * Math.Sin(P)
                yP = a * Math.Sin(phi) * Math.Cos(P)
                'omzetting xP, yP in x, y dit zijn de gevraagde coördinaten van het schaduwpunt t.o.v. het zonnewijzer assenstelsel
                x = Xoorsprong + xP
                y = YFlip(Yoorsprong + yP)
                If x > 0 And x < Me.Width And y > 0 And y < Me.Height Then
                    NT.DrawLine(myPen, x, y - 10, x, y + 10)
                    NT.DrawLine(myPen, x - 10, y, x + 10, y)
                    If uur + 12 <> 24 Then
                        NT.DrawString(uur + 12, New Font(LetterType, Lettergrootte), Brushes.Black, x - 10 + 15 * Math.Sign(phi), y)
                    End If
                End If

            End If

        Next



        'Streepjes van de eerste van de maand
        Uurhoek = 0
        For i = 1 To 12
            decl = declinatie(L(DagNummer(2018, i, 1) + 0.5))
            x0 = 0
            y0 = 0
            z0 = 1
            Omzettingx0yo()
            Omzettingx1y1()

            If z1 > 0 Then
                yMaand = a * Math.Tan(decl) * Math.Cos(phi)
                y = YFlip(Yoorsprong + yMaand)
                If i <= 6 Then
                    NT.DrawLine(myPen, Xoorsprong, y, Xoorsprong + 40, y)
                    x = Xoorsprong + 10
                Else
                    NT.DrawLine(myPen, Xoorsprong, y, Xoorsprong - 40, y)
                    x = Xoorsprong - 30
                End If
                NT.DrawString(MaandNaam(i), New Font(LetterType, Lettergrootte), Brushes.Black, x, y - 12)
            End If
        Next

        myPen = New Pen(Brushes.Chocolate, 2)
        myPen.DashStyle = Drawing.Drawing2D.DashStyle.DashDotDot
        NT.DrawLine(myPen, Xoorsprong, 0, Xoorsprong, Hoogte)

        Me.BackgroundImage = BTM
        NT.Dispose()

    End Sub

End Class